<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>Unit Level Functions</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<table width=100%>
<tr>
  <td bgcolor="black" width="1"><a href="http://www.ti.com"><img border=0 src="../../tilogo.gif"></a></td>
  <td bgcolor="red"><img src="../../titagline.gif"></td>
</tr>
</table>
<!-- Generated by Doxygen 1.8.11 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">Unit Level Functions<div class="ingroups"><a class="el" href="group___g_t_r_a_c_k___internal.html">Internals</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Internal UNIT level API, called by MODULE.  
<a href="#details">More...</a></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:gaa77d1e9a2f3a64c3b529c4ebd7061d5a"><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___g_t_r_a_c_k___a_l_g___u_n_i_t___f_u_n_c_t_i_o_n.html#gaa77d1e9a2f3a64c3b529c4ebd7061d5a">gtrack_unitCreate</a> (<a class="el" href="struct_tracking_params.html">TrackingParams</a> *params, int32_t *errCode)</td></tr>
<tr class="separator:gaa77d1e9a2f3a64c3b529c4ebd7061d5a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga2eaf3756d981a29fa4a6608f98cce1d6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___g_t_r_a_c_k___a_l_g___u_n_i_t___f_u_n_c_t_i_o_n.html#ga2eaf3756d981a29fa4a6608f98cce1d6">gtrack_unitDelete</a> (void *handle)</td></tr>
<tr class="separator:ga2eaf3756d981a29fa4a6608f98cce1d6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga28b01cfed835e3101f7ecfe898c5afad"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___g_t_r_a_c_k___a_l_g___u_n_i_t___f_u_n_c_t_i_o_n.html#ga28b01cfed835e3101f7ecfe898c5afad">gtrack_unitEvent</a> (void *handle, uint16_t num)</td></tr>
<tr class="separator:ga28b01cfed835e3101f7ecfe898c5afad"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga00b3865f1f0176eee220db80cac2309e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___g_t_r_a_c_k___a_l_g___u_n_i_t___f_u_n_c_t_i_o_n.html#ga00b3865f1f0176eee220db80cac2309e">gtrack_unitPredict</a> (void *handle)</td></tr>
<tr class="separator:ga00b3865f1f0176eee220db80cac2309e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga288560456dff7cf2ca2be6d168ff1717"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___g_t_r_a_c_k___a_l_g___u_n_i_t___f_u_n_c_t_i_o_n.html#ga288560456dff7cf2ca2be6d168ff1717">gtrack_unitReport</a> (void *handle, <a class="el" href="struct_g_t_r_a_c_k__target_desc.html">GTRACK_targetDesc</a> *target)</td></tr>
<tr class="separator:ga288560456dff7cf2ca2be6d168ff1717"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga480b437835aa811dbff0b2786f068179"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___g_t_r_a_c_k___a_l_g___u_n_i_t___f_u_n_c_t_i_o_n.html#ga480b437835aa811dbff0b2786f068179">gtrack_unitScore</a> (void *handle, <a class="el" href="struct_g_t_r_a_c_k__measurement_point.html">GTRACK_measurementPoint</a> *point, float *bestScore, uint8_t *bestInd, uint16_t num)</td></tr>
<tr class="separator:ga480b437835aa811dbff0b2786f068179"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gac9721e68758aae9773796c303ca77def"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___g_t_r_a_c_k___a_l_g___u_n_i_t___f_u_n_c_t_i_o_n.html#gac9721e68758aae9773796c303ca77def">gtrack_unitStart</a> (void *handle, uint64_t timeStamp, uint32_t tid, float *um)</td></tr>
<tr class="separator:gac9721e68758aae9773796c303ca77def"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ga04d4b956bc159beca7e45e183928399d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___g_t_r_a_c_k___a_l_g___u_n_i_t___f_u_n_c_t_i_o_n.html#ga04d4b956bc159beca7e45e183928399d">gtrack_unitStop</a> (void *handle)</td></tr>
<tr class="separator:ga04d4b956bc159beca7e45e183928399d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:gad9bb8a60e6a86d5bb07f389c015268db"><td class="memItemLeft" align="right" valign="top"><a class="el" href="gtrack__int_8h.html#a5e9684d2e87fbf099474d8ece4c3a69c">TrackState</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="group___g_t_r_a_c_k___a_l_g___u_n_i_t___f_u_n_c_t_i_o_n.html#gad9bb8a60e6a86d5bb07f389c015268db">gtrack_unitUpdate</a> (void *handle, <a class="el" href="struct_g_t_r_a_c_k__measurement_point.html">GTRACK_measurementPoint</a> *point, <a class="el" href="struct_g_t_r_a_c_k__measurement_variance.html">GTRACK_measurementVariance</a> *var, uint8_t *pInd, uint16_t num)</td></tr>
<tr class="separator:gad9bb8a60e6a86d5bb07f389c015268db"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<p>Internal UNIT level API, called by MODULE. </p>
<h2 class="groupheader">Function Documentation</h2>
<a class="anchor" id="gaa77d1e9a2f3a64c3b529c4ebd7061d5a"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void* gtrack_unitCreate </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="struct_tracking_params.html">TrackingParams</a> *&#160;</td>
          <td class="paramname"><em>params</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int32_t *&#160;</td>
          <td class="paramname"><em>errCode</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 GTRACK Module calls this function to instantiate GTRACK Unit with desired configuration parameters. Function returns a handle, which is used my module to call units' methods</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">params</td><td>This is a pointer to the configuration structure. The structure contains all parameters that are exposed by GTRACK alrorithm. The configuration does not need to persist. </td></tr>
    <tr><td class="paramdir">[out]</td><td class="paramname">errCode</td><td>Error code populated on error, see <a class="el" href="group___g_t_r_a_c_k___e_r_r_o_r___c_o_d_e.html">Algorithm Error codes</a></td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">Handle</td><td>to GTRACK unit </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga2eaf3756d981a29fa4a6608f98cce1d6"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gtrack_unitDelete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>handle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 GTRACK Module calls this function to delete the instance of GTRACK Unit</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>This is handle to GTARCK unit</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">None</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga28b01cfed835e3101f7ecfe898c5afad"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gtrack_unitEvent </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>num</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 GTRACK Module calls this function to run GTRACK unit level state machine</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>This is handle to GTARCK unit </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>This is number of associated measurments</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">None</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga00b3865f1f0176eee220db80cac2309e"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gtrack_unitPredict </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>handle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 GTRACK Module calls this function to run GTRACK unit prediction step</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>This is handle to GTRACK unit</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">None</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga288560456dff7cf2ca2be6d168ff1717"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gtrack_unitReport </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_g_t_r_a_c_k__target_desc.html">GTRACK_targetDesc</a> *&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 GTRACK Module calls this function to report GTRACK unit results to the target descriptor</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>This is handle to GTRACK unit </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">target</td><td>This is a pointer to a target descriptor</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">None</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga480b437835aa811dbff0b2786f068179"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gtrack_unitScore </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_g_t_r_a_c_k__measurement_point.html">GTRACK_measurementPoint</a> *&#160;</td>
          <td class="paramname"><em>point</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>bestScore</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>bestInd</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>num</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 GTRACK Module calls this function to obtain the measurement vector scoring from the GTRACK unit perspective</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>This is handle to GTRACK unit </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">point</td><td>This is an array of measurement points </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">bestScore</td><td>This is a pointer current scoresheet with best scores. Only better scores are updated </td></tr>
    <tr><td class="paramdir">[in,out]</td><td class="paramname">bestInd</td><td>This is a pointer current scoresheet winners. Only better scores winners are updated </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Number of measurement points</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">None</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gac9721e68758aae9773796c303ca77def"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gtrack_unitStart </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint64_t&#160;</td>
          <td class="paramname"><em>timeStamp</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>tid</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float *&#160;</td>
          <td class="paramname"><em>um</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 GTRACK Module calls this function to start target tracking. This function is called during modules' allocation step, once new set of points passes allocation thresholds</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>This is handle to GTRACK unit </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">timeStamp</td><td>This is an allocation time stamp </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">tid</td><td>This is a target identifier given to a unit </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">um</td><td>This is a pointer to the parental centroid</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">None</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="ga04d4b956bc159beca7e45e183928399d"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gtrack_unitStop </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>handle</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 GTRACK Module calls this function to stop target tracking. This function is called when Tracking state transitions to FREE</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>This is handle to GTRACK unit</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">None</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="gad9bb8a60e6a86d5bb07f389c015268db"></a>
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="gtrack__int_8h.html#a5e9684d2e87fbf099474d8ece4c3a69c">TrackState</a> gtrack_unitUpdate </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_g_t_r_a_c_k__measurement_point.html">GTRACK_measurementPoint</a> *&#160;</td>
          <td class="paramname"><em>point</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="struct_g_t_r_a_c_k__measurement_variance.html">GTRACK_measurementVariance</a> *&#160;</td>
          <td class="paramname"><em>var</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint8_t *&#160;</td>
          <td class="paramname"><em>pInd</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint16_t&#160;</td>
          <td class="paramname"><em>num</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p><b>Description</b> <br />
 GTRACK Module calls this function to perform an update step for the tracking unit.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[in]</td><td class="paramname">handle</td><td>This is handle to GTRACK unit </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">point</td><td>This is an array of measurement points </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">var</td><td>Pointer to an array of input measurment variances. Shall be set to NULL if variances are unknown </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">pInd</td><td>This is an array of associated UIDs. After association and allocation steps, each measurment shall have a UID assigned. </td></tr>
    <tr><td class="paramdir">[in]</td><td class="paramname">num</td><td>Number of measurement points</td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">None</td><td></td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<hr size="1"><small>
Copyright  2018, Texas Instruments Incorporated</small>
</body>
</html>
